home/urls.py
from django.urls import path

import home.views as views

app_name = "home"
urlpatterns = [
    path('', views.home, name='home'),
    path("signup/", views.signup, name='signup'),
    path("logout/", views.logout, name='logout'),
    path("login/", views.login, name='login'),
    path("create-movie/", views.create_movie, name='create-movie'),
    path("create-series/", views.create_series, name='create-series'),
    path("create-season/", views.create_season, name='create-season'),
    path("create-episode/", views.create_episode, name='create-episode'),
    path("provider-series/<str:identifier>", views.get_provider_series, name='provider-series'),
    path("provider-season/<str:identifier>", views.get_provider_seasons, name='provider-season'),
]

imdb/urls.py
from django.contrib import admin
from django.urls import path

import home.urls as home_urls
from django.conf.urls import include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(home_urls, namespace='home')),
]

home/models.py
from django.db import models
from django.utils.crypto import get_random_string


class Provider(models.Model):
    identifier = models.CharField(default=get_random_string, max_length=12, unique=True)
    name = models.CharField(max_length=128)
    email = models.CharField(max_length=128)

    @classmethod
    def get_provider(cls, provider_token):
        return cls.objects.filter(identifier=provider_token).first()


class Content(models.Model):
    rate = models.FloatField()
    name = models.CharField(max_length=128)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    description = models.TextField()
    release_date = models.DateTimeField()
    provider = models.ForeignKey(Provider, on_delete=models.SET_NULL, null=True)


class Genre(models.Model):
    name = models.CharField(max_length=128)


class ContentGenre(models.Model):
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    genre = models.ForeignKey(Genre, on_delete=models.CASCADE)


class File(models.Model):
    extension = models.CharField(max_length=8)
    name = models.CharField(max_length=256)
    url = models.CharField(max_length=256)
    created_at = models.DateTimeField(auto_now_add=True)
    size = models.IntegerField()


class Trailer(models.Model):
    identifier = models.CharField(default=get_random_string, max_length=12, unique=True)
    length = models.DurationField()
    resolution = models.CharField(max_length=6)
    file = models.ForeignKey(File, on_delete=models.CASCADE)

    @classmethod
    def get_trailer(cls, identifier):
        return cls.objects.filter(identifier=identifier).first()


class Image(models.Model):
    identifier = models.CharField(default=get_random_string, max_length=12, unique=True)
    width = models.CharField(max_length=8)
    height = models.CharField(max_length=8)
    file = models.ForeignKey(File, on_delete=models.CASCADE)

    @classmethod
    def get_image(cls, identifier):
        return cls.objects.filter(identifier=identifier).first()


class Movie(models.Model):
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    length = models.DurationField()
    trailer = models.ForeignKey(Trailer, on_delete=models.SET_NULL, null=True)
    image = models.ForeignKey(Image, on_delete=models.SET_NULL, null=True)


class Series(models.Model):
    identifier = models.CharField(default=get_random_string, max_length=12, unique=True)
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    trailer = models.ForeignKey(Trailer, on_delete=models.SET_NULL, null=True)
    image = models.ForeignKey(Image, on_delete=models.SET_NULL, null=True)

    @classmethod
    def get_series(cls, id):
        return cls.objects.filter(identifier=id).first()


class Season(models.Model):
    identifier = models.CharField(default=get_random_string, max_length=12, unique=True)
    index = models.IntegerField()
    release_date = models.DateTimeField()
    series = models.ForeignKey(Series, on_delete=models.CASCADE)
    trailer = models.ForeignKey(Trailer, on_delete=models.SET_NULL, null=True)
    image = models.ForeignKey(Image, on_delete=models.SET_NULL, null=True)

    @classmethod
    def get_season(cls, id):
        return cls.objects.filter(identifier=id).first()


class Episode(models.Model):
    season = models.ForeignKey(Season, on_delete=models.CASCADE)
    index = models.IntegerField()
    release_date = models.DateTimeField()
    name = models.CharField(max_length=128)
    trailer = models.ForeignKey(Trailer, on_delete=models.SET_NULL, null=True)
    image = models.ForeignKey(Image, on_delete=models.SET_NULL, null=True)


class Actor(models.Model):
    birth_date = models.DateTimeField()
    name = models.CharField(max_length=32)
    email = models.CharField(max_length=128)
    image = models.ForeignKey(Image, on_delete=models.SET_NULL, null=True)


class ContentActor(models.Model):
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    actor = models.ForeignKey(Actor, on_delete=models.CASCADE)

home/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.forms import Form, ModelForm
import home.models as models


class SignUpForm(UserCreationForm):
    email = forms.EmailField(max_length=254, help_text='Required. Inform a valid email address.')

    class Meta:
        model = User
        fields = ('username', 'email', 'password1', 'password2')


class LoginForm(Form):
    username = forms.CharField(max_length=128)
    password = forms.CharField(widget=forms.PasswordInput)

    class Meta:
        fields = ['username', 'password']


class MovieForm(ModelForm):
    provider_token = forms.CharField(max_length=12)
    length = forms.DurationField()
    trailer_id = forms.CharField(max_length=12, required=False)
    image_id = forms.CharField(max_length=12, required=False)

    class Meta:
        model = models.Content
        fields = ['rate', 'name', 'description', 'release_date', 'provider_token', 'length', 'trailer_id', 'image_id']


class SeriesForm(ModelForm):
    provider_token = forms.CharField(max_length=12)
    trailer_id = forms.CharField(max_length=12, required=False)
    image_id = forms.CharField(max_length=12, required=False)

    class Meta:
        model = models.Content
        fields = ['rate', 'name', 'description', 'release_date', 'provider_token', 'trailer_id', 'image_id']


class SeasonForm(Form):
    index = forms.IntegerField()
    release_date = forms.DateTimeField()
    trailer_id = forms.CharField(max_length=12, required=False)
    image_id = forms.CharField(max_length=12, required=False)
    series_id = forms.CharField(max_length=12)


class EpisodeForm(Form):
    index = forms.IntegerField()
    release_date = forms.DateTimeField()
    name = forms.CharField(max_length=128)
    trailer_id = forms.CharField(max_length=12, required=False)
    image_id = forms.CharField(max_length=12, required=False)
    season_id = forms.CharField(max_length=12)


class FilterForm(Form):
    start_date = forms.DateTimeField(required=False)
    end_date = forms.DateTimeField(required=False)
    name = forms.CharField(max_length=128, required=False)
    actor = forms.CharField(max_length=128, required=False)
    rate = forms.FloatField(required=False)

home/views.py
from django.contrib.auth import login as login_user, authenticate
from django.http import JsonResponse

from home.models import Provider, Content, Movie, Trailer, Image, Series, Season, Episode, Actor
from .forms import SignUpForm, LoginForm, MovieForm, SeriesForm, SeasonForm, EpisodeForm, FilterForm
from django.contrib.auth import logout as logout_user
from django.shortcuts import render, redirect

from django.utils.dateparse import parse_duration


def home(request):
    if request.method == 'POST':
        form = FilterForm(request.POST)
        if form.is_valid():
            queryset = Content.objects.all()
            if form.data['start_date']:
                queryset = queryset.filter(release_date__gte=form.data['start_date'])
            if form.data['end_date']:
                queryset = queryset.filter(release_date__lte=form.data['end_date'])
            if form.data['rate']:
                queryset = queryset.filter(rate__gte=form.data['rate'])
            if form.data['name']:
                queryset = queryset.filter(name__contains=form.data['name'])
            if form.data['actor']:
                actor = Actor.objects.filter(name=form.data['actor']).first()
                queryset = queryset.filter(contentactor__actor=actor)
            movies = Movie.objects.filter(content_id__in=queryset)
            series = Series.objects.filter(content_id__in=queryset)
            return render(request, 'home.html', {'form': form, 'movies': movies, 'series': series})
    else:
        form = FilterForm()
        return render(request, 'home.html', {'form': form})


def signup(request):
    if request.method == 'POST':
        form = SignUpForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get('username')
            raw_password = form.cleaned_data.get('password1')
            user = authenticate(username=username, password=raw_password)
            login_user(request, user)
            return redirect('home:home')
    else:
        form = SignUpForm()
        return render(request, 'signup.html', {'form': form})


def login(request):
    if request.method == 'POST':
        form = LoginForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data.get('username')
            raw_password = form.cleaned_data.get('password')
            user = authenticate(username=username, password=raw_password)
            if user:
                login_user(request, user)
            else:
                redirect('home:login')
        return redirect('home:home')
    else:
        form = LoginForm()
        return render(request, 'login.html', {'form':form})


def logout(request):
    if request.method == 'GET':
        logout_user(request)
        return redirect('home:home')


def get_trailer(trailer):
    if trailer:
        trailer = Trailer.get_trailer(trailer)
        if trailer:
            return trailer, False
        else:
            return None, True
    else:
        return None, False


def get_image(image):
    if image:
        image = Image.get_image(image)
        if image:
            return image, False
        else:
            return None, True
    else:
        return None, False


def create_movie(request):
    if request.method == 'POST':
        form = MovieForm(request.POST)
        if form.is_valid():
            provider = Provider.get_provider(form.data['provider_token'])
            trailer, t_status = get_trailer(form.data['trailer_id'])
            image, i_status = get_image(form.data['image_id'])
            if not provider:
                return redirect('home:create-movie')
            if t_status or i_status:
                return redirect('home:create-movie')
            content = Content.objects.create(rate=form.data['rate'], release_date=form.data['release_date'],
                                             name=form.data['name'], description=form.data['description'],
                                             provider=provider)
            Movie.objects.create(content=content, length=parse_duration(form.data['length']), trailer=trailer, image=image)
            return redirect('home:home')
    else:
        form = MovieForm()
        return render(request, 'movie-creation.html', {'form': form})


def create_series(request):
    if request.method == 'POST':
        form = SeriesForm(request.POST)
        if form.is_valid():
            provider = Provider.get_provider(form.data['provider_token'])
            trailer, t_status = get_trailer(form.data['trailer_id'])
            image, i_status = get_image(form.data['image_id'])
            if not provider:
                return redirect('home:create-series')
            if t_status or i_status:
                return redirect('home:create-series')
            content = Content.objects.create(rate=form.data['rate'], release_date=form.data['release_date'],
                                             name=form.data['name'], description=form.data['description'],
                                             provider=provider)
            Series.objects.create(content=content, trailer=trailer, image=image)
            return redirect('home:home')
    else:
        form = SeriesForm()
        return render(request, 'series-creation.html', {'form': form})


def create_season(request):
    if request.method == 'POST':
        form = SeasonForm(request.POST)
        if form.is_valid():
            series = Series.get_series(form.data['series_id'])
            trailer, t_status = get_trailer(form.data['trailer_id'])
            image, i_status = get_image(form.data['image_id'])
            if not series:
                return redirect('home:create-season')
            if t_status or i_status:
                return redirect('home:create-season')

            Season.objects.create(index=form.data['index'], series=series, release_date=form.data['release_date'],
                                  trailer=trailer, image=image)
            return redirect('home:home')
    else:
        form = SeasonForm()
        return render(request, 'season-creation.html', {'form': form})


def create_episode(request):
    if request.method == 'POST':
        form = EpisodeForm(request.POST)
        if form.is_valid():
            season = Season.get_season(form.data['season_id'])
            trailer, t_status = get_trailer(form.data['trailer_id'])
            image, i_status = get_image(form.data['image_id'])
            if not season:
                return redirect('home:create-season')
            if t_status or i_status:
                return redirect('home:create-season')
            Episode.objects.create(index=form.data['index'], release_date=form.data['release_date'],
                                   name=form.data['name'], season=season, trailer=trailer, image=image)
            return redirect('home:home')
    else:
        form = EpisodeForm()
        return render(request, 'episode-creation.html', {'form': form})


def get_provider_series(request, identifier):
    series = Series.objects.select_related('content').filter(content__provider__identifier=identifier)
    result = {}
    for item in series:
        result[item.content.name] = item.identifier
    return JsonResponse(result)


def get_provider_seasons(request, identifier):
    seasons = Season.objects.select_related('series__content').filter(series__content__provider__identifier=identifier)
    result = {}
    for item in seasons:
        result[str((item.series.content.name, item.index))] = item.identifier
    return JsonResponse(result)

home/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.js"></script>


    {# scripts #}
    {# order matters jquery semantic #}
    <title>{% block title %}Imdb{% endblock %}</title>
    <meta content="text/html" charset="UTF-8">
    {% block extra_header %}{% endblock %}

    <style>
        #menu_item:hover {
            background-color: red;
        }
        #inbox-icon:hover {
            background-color: red;
        }
    </style>


</head>
<body style="background-color: #F8F8F8">

<div>
    {% block top_bar %}
        {% include 'top_bar.html' %}
    {% endblock %}

    <div id="body-container">
        {% block body %}{% endblock %}
    </div>
    {% block items %} {% endblock %}
</div>

</body>
</html>

home/templates/base_menu.html
<div class="ui labeled icon inverted menu">
    {% block menu_tags %}{% endblock %}
</div>

home/templates/episode-creation.html
{% extends 'base.html' %}

{% block body %}
  <h2>Episode Creation</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock %}

home/templates/home.html
{% extends 'base.html' %} {% load semanticui %}

{% block body %}
    <div class="ui centered grid" style="margin-top: 5em">
        <div class="ui row">
            <div class="ui segment">
                <form class = "ui form" method="post">
                    {% csrf_token %}
                    {% render_form form %}
                    <button class="ui green button" type="submit">Search</button>
                </form>
            </div>
        </div>
    </div>
    {% if movies or series %}
        <div class="ui centered grid" style="margin-left: 5em; margin-right: 5em">
            {% for item in movies %}
                <div class="four wide column">
                    <div class="ui segment">
                        <div class="ui red label" style="margin-bottom: 1em">Movie</div>
                        <p>{{ item.content.name }}</p>
                        <p>release date: {{ item.content.release_date }}</p>
                        <p>rate: {{ item.content.rate }}</p>
                        <p>
                            cast: {% for content_actor in item.content.contentactor_set.all %}
                                {{ content_actor.actor.name }}
                            {% endfor %}
                        </p>
                    </div>
                </div>
            {% endfor %}
            {% for item in series %}
                <div class="four wide column">
                    <div class="ui segment">
                        <div class="ui blue label" style="margin-bottom: 1em">Series</div>
                        <p>{{ item.content.name }}</p>
                        <p>release date: {{ item.content.release_date }}</p>
                        <p>rate: {{ item.content.rate }}</p>
                        <p>
                            cast: {% for content_actor in item.content.contentactor_set.all %}
                                {{ content_actor.actor.name }}
                            {% endfor %}
                        </p>
                    </div>
                </div>
            {% endfor %}
        </div>
    {% endif %}
{% endblock %}

home/templates/logged_in.html
{% extends 'base_menu.html' %}

{% block menu_tags %}
    <a href="{% url 'home:home' %}" class="item" id="menu_item">
        <i class="home icon"></i>
        Home
    </a>
    <a href="{% url 'home:logout' %}" class="right floated item" id="menu_item">
        <i class="sign-out icon"></i>
        Logout
    </a>

{% endblock %}

home/templates/login.html
{% extends 'base.html' %}

{% block body %}
  <h2>Login</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Login</button>
  </form>
{% endblock %}

home/templates/movie-creation.html
{% extends 'base.html' %}

{% block body %}
  <h2>Movie Creation</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock %}

home/templates/not_logged_in.html
{% extends 'base_menu.html' %}

{% block menu_tags %}
    <a href="{% url 'home:home' %}" class="item" id="menu_item">
            <i class="home icon"></i>
            Home
    </a>
    <a href="{% url 'home:login' %}" class="right floated item" id="menu_item">
        <i class="sign-in icon"></i>
        Login
    </a>
    <a href="{% url 'home:signup' %}" class="item" id="menu_item">
        <i class="id card icon"></i>
        Sign Up
    </a>
{% endblock %}

home/templates/season-creation.html
{% extends 'base.html' %}

{% block body %}
  <h2>Season Creation</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock %}

home/templates/series-creation.html
{% extends 'base.html' %}

{% block body %}
  <h2>Series Creation</h2>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
{% endblock %}

home/templates/signup.html
{% extends 'base.html' %}

{% block body %}
  <h2>Sign up</h2>
  <form method="post">
    {% csrf_token %}
    {% for field in form %}
      <p>
        {{ field.label_tag }}<br>
        {{ field }}
        {% if field.help_text %}
          <small style="color: grey">{{ field.help_text }}</small>
        {% endif %}
        {% for error in field.errors %}
          <p style="color: red">{{ error }}</p>
        {% endfor %}
    {% endfor %}
    <button type="submit">Sign up</button>
  </form>
{% endblock %}

home/templates/top_bar.html
{% if request.user.is_authenticated %}
    {% include 'logged_in.html' %}
{% else %}
    {% include 'not_logged_in.html' %}
{% endif %}